--    Copyright (C) 2004 by neuron                                          
--    aagaande@gmail.com                                             
--                                                                          
--    This program is free software; you can redistribute it and--or modify  
--    it under the terms of the GNU General Public License as published by  
--    the Free Software Foundation; either version 2 of the License, or     
--    (at your option) any later version.                                   
--                                                                          
--    This program is distributed in the hope that it will be useful,       
--    but WITHOUT ANY WARRANTY; without even the implied warranty of        
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
--    GNU General Public License for more details.                          
--                                                                          
--    You should have received a copy of the GNU General Public License     
--    along with this program; if not, write to the                         
--    Free Software Foundation, Inc.,                                       
--    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 

-- Todo, more MinionHeader options, play sound, support notify through MikSbt/SCT

local moduleName = "MinionHeader"
local MinionHeader = nQuestLog:NewModule(moduleName,"AceEvent-2.0","AceHook-2.1", "AceConsole-2.0")
local quixote = AceLibrary("Quixote-1.0")
local dewdrop = AceLibrary("Dewdrop-2.0")

local L = AceLibrary("AceLocale-2.2"):new(moduleName)
L:RegisterTranslations("enUS", function() return {
    ["Description"] = "Shows the nQuestLog header in the minion",
    ["Zone visibility:"] = true,
    ["Toggle showing"] = true,
} end)

function MinionHeader:OnModuleLoad()
	self.description = L["Description"]
	
	self.core:RegisterDefaults(moduleName, "profile", {
		["enabled"] = false,
	})
end

function MinionHeader:OnRightClick()
	local popupMenu = {
		type='group',
		args = {
			header = {
				type="header",
				name=L["Zone visibility:"],
				order=1,
			}
		},
	}
	
	for i,zone in quixote:IterZones() do
		prettyzone = self.core:Colorize(zone,"zoneHeader")
		popupMenu.args[zone] = {
			order = i + 5,
			name = prettyzone,
			type = "toggle",
			desc = L["Toggle showing"] .. " " .. zone,
			get = function()
				return not self.core.db.char.hiddenZones[zone]
			end,
			set = function(v)
				self.core.db.char.hiddenZones[zone] = nil
				if (not v) then
					self.core.db.char.hiddenZones[zone] = true
				end
				self.core:Refresh()
			end
		}
	end
	
	dewdrop:Open( nQuestLogFrame,
		'children', function() dewdrop:FeedAceOptionsTable(popupMenu ) end,
		'cursorX', true, 'cursorY', true )
end

function MinionHeader:ToggleEnabled(v)
	self.db.profile.enabled = v
	if (v) then
		nQuestHeaderText:SetText(self.core:Colorize("nQuestLog","trackerHeader"))
		nQuestHeader:SetPoint("TOPLEFT",nQuestLogFrame,"TOPLEFT",5,-5)
		nQuestHeader:SetHeight(nQuestHeaderText:GetHeight())
		
		nQuestHeader:Show()
		nQuestLogButton1:ClearAllPoints()
		nQuestLogButton1:SetPoint("TOPLEFT",nQuestHeader,"BOTTOMLEFT",0,0)
		self.core:Refresh()
	else
		nQuestHeader:Hide()
		nQuestLogButton1:ClearAllPoints()
		nQuestLogButton1:SetPoint("TOPLEFT",nQuestLogFrame,"TOPLEFT",5,-5)
		self.core:Refresh()
	end
end
